#include "gif_lib.h"

#include <ruby.h>

#include <stdlib.h>

static VALUE mkgif(VALUE obj, VALUE lines, VALUE out) {
    int i, j, k, l, m, n, x, y;
    int MAX_X = 400;
    int MAX_Y = 300;
    int G_MAX_X = MAX_X;
    int G_MAX_Y = MAX_Y;
    GifFileType* gif = EGifOpenFileName(RSTRING(out)->ptr, 0);
    int frame = (*(RSTRING(out)->ptr) != 't');
    ColorMapObject* cmap = MakeMapObject(2+frame*2, NULL);
    GifByteType* buf;
    if (frame) {
        cmap->Colors[2].Red = 74;
        cmap->Colors[2].Green = 47;
        cmap->Colors[2].Blue = 5;
        MAX_X += 22;
        MAX_Y += 22;
        frame = 11;
    }
    buf = (GifByteType*)malloc(MAX_X*MAX_Y*sizeof(GifByteType));
    cmap->Colors[0].Red = 0;
    cmap->Colors[0].Green = 64;
    cmap->Colors[0].Blue = 64;
    cmap->Colors[1].Red = 255;
    cmap->Colors[1].Green = 255;
    cmap->Colors[1].Blue = 255;
    EGifPutScreenDesc(gif, MAX_X, MAX_Y, 1, 0, cmap);
    EGifPutImageDesc(gif, 0, 0, MAX_X, MAX_Y, 0, NULL);
    for (i = 0; i < MAX_Y; i++) {
        for (j = 0; j < MAX_X; j++) {
            if (frame && (i < 11 || i >= MAX_Y-11 || j < 11 || j >= MAX_X-11))
                buf[i*MAX_X+j] = 2;
            else
                buf[i*MAX_X+j] = 0;
        }
    }
    for (i = 0; i < RARRAY(lines)->len; i+=2) {
        x = NUM2INT(RARRAY(lines)->ptr[i]);
        y = NUM2INT(RARRAY(lines)->ptr[i+1]);
        for (k = -1; k <= 1; k++) {
            n = y+k;
            if (n < 0 || n >= G_MAX_Y) continue;
            n += frame;
            for (l = -1; l <= 1; l++) {
                m = x+l;
                if (m < 0 || m >= G_MAX_X) continue;
                buf[n*MAX_X+m+frame] = 1;
            }
        }
    }
    for (i = 0; i < MAX_Y; i++) {
        EGifPutLine(gif, buf, MAX_X);
        buf += MAX_X;
    }
    EGifCloseFile(gif);

    return Qtrue;
}

void Init_mkgif() {
    rb_define_global_function("mkgif", mkgif, 2);
}
