#!/usr/bin/env ruby

require 'util'
require 'loadimg'

@db = get_udb

def wait(u)
  update = @db.transaction do
    if !@db.root?(u)
      @db[u] = {}
    end

    # for reloading
    if @db[u].key?(:pid)
      begin
        Process.kill(:HUP, @db[u][:pid])
      rescue
      end
    end

    @db[u][:pid] = $$
    @db[u][:last] = Time.now
    up = @db[u][:up]
    @db[u].delete(:up)
    up
  end

  if update
    loadimg
    exit 0
  end

  sleep(60)

  @db.transaction do
    if @db[u][:pid] == $$
      @db[u].delete(:pid)
    end
  end
  loadimg
  exit 0
end

u = query

trap(:USR1) do
  @db.transaction do
    @db[u].delete(:pid)
  end
  loadimg
  exit 0
end

wait(u)
